library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity XADC_TEST is
    Port (
        do_out : OUT STD_LOGIC_VECTOR(15 DOWNTO 0);
        dclk_in : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        vp_in : IN STD_LOGIC;
        vn_in : IN STD_LOGIC);
end XADC_TEST;

architecture Behavioral of XADC_TEST is

    COMPONENT xadc_fpro
      PORT (
        di_in : IN STD_LOGIC_VECTOR(15 DOWNTO 0);
        daddr_in : IN STD_LOGIC_VECTOR(6 DOWNTO 0);
        den_in : IN STD_LOGIC;
        dwe_in : IN STD_LOGIC;
        drdy_out : OUT STD_LOGIC;
        do_out : OUT STD_LOGIC_VECTOR(15 DOWNTO 0);
        dclk_in : IN STD_LOGIC;
        reset_in : IN STD_LOGIC;
        vp_in : IN STD_LOGIC;
        vn_in : IN STD_LOGIC;
        channel_out : OUT STD_LOGIC_VECTOR(4 DOWNTO 0);
        eoc_out : OUT STD_LOGIC;
        alarm_out : OUT STD_LOGIC;
        eos_out : OUT STD_LOGIC;
        busy_out : OUT STD_LOGIC
      );
    END COMPONENT;

    SIGNAL di_in :  STD_LOGIC_VECTOR(15 DOWNTO 0);
    SIGNAL daddr_in : STD_LOGIC_VECTOR(6 DOWNTO 0);
    SIGNAL drdy_out : STD_LOGIC;
    SIGNAL channel_out : STD_LOGIC_VECTOR(4 DOWNTO 0);
    SIGNAL eoc_out : STD_LOGIC;
    SIGNAL alarm_out : STD_LOGIC;
    SIGNAL eos_out : STD_LOGIC;
    SIGNAL busy_out : STD_LOGIC;
    
begin
    daddr_in <= "00" & channel_out;
    
    your_instance_name : xadc_fpro
      PORT MAP (
        di_in => x"0000",
        daddr_in => daddr_in,
        den_in => eoc_out,
        dwe_in => '0',
        drdy_out => drdy_out,
        do_out => do_out,
        dclk_in => dclk_in,
        reset_in => reset,
        vp_in => vp_in,
        vn_in => vn_in,
        channel_out => channel_out,
        eoc_out => eoc_out,
        alarm_out => alarm_out,
        eos_out => eos_out,
        busy_out => busy_out
      );

end Behavioral;
