library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity XADC_TEST_tb is
end XADC_TEST_tb;

architecture Behavioral of XADC_TEST_tb is
    component XADC_TEST is
    Port (
        do_out : OUT STD_LOGIC_VECTOR(15 DOWNTO 0);
        dclk_in : IN STD_LOGIC;
        reset : IN STD_LOGIC;
        vp_in : IN STD_LOGIC;
        vn_in : IN STD_LOGIC);
    end component;
    
    SIGNAL di_in :  STD_LOGIC_VECTOR(15 DOWNTO 0);
    SIGNAL daddr_in : STD_LOGIC_VECTOR(6 DOWNTO 0);
    SIGNAL drdy_out : STD_LOGIC;
    SIGNAL do_out : STD_LOGIC_VECTOR(15 DOWNTO 0);
    SIGNAL dclk_in : STD_LOGIC;
    SIGNAL reset_in : STD_LOGIC;
    SIGNAL vp_in : STD_LOGIC;
    SIGNAL vn_in : STD_LOGIC;
    SIGNAL channel_out : STD_LOGIC_VECTOR(4 DOWNTO 0);
    SIGNAL eoc_out : STD_LOGIC;
    SIGNAL alarm_out : STD_LOGIC;
    SIGNAL eos_out : STD_LOGIC;
    SIGNAL busy_out : STD_LOGIC;
    constant clk_period : time := 10 ns;  -- Sets clock to ~ 100MHz

begin
    daddr_in <= "00" & channel_out;

    clk_process :process
    begin
		dclk_in <= '0';
		wait for clk_period/2;
		dclk_in <= '1';
		wait for clk_period/2;
    end process;
    
    sim_process : process
    begin
    	 reset_in <= '1', '0' after 10 ns;
    	 wait;
    end process;
    
    uut : XADC_TEST 
        PORT MAP(
            do_out => do_out,
            dclk_in => dclk_in,
            reset => reset_in,
            vp_in => vp_in,
            vn_in => vn_in);

end Behavioral;
